#!/usr/local/bin/perl
#-------------------------------------------
# MiniSearch v0.1
# Personal Website Search Engine
# http://www.dansteinman.com/search/
#
# Copyright (C) 1999 Dan Steinman
# Distributed under the terms of the of the GNU General Public License
# You may modify this file, redistribute it, but any significant improvements must be made public
# Read the LICENSE file for more details
#-------------------------------------------
# search-index.pl
# indexes all the words in all the pages (must be run first before searching anything)
#-------------------------------------------

$root = "$ENV{'DOCUMENT_ROOT'}";				# finds the path to your files
$datadir = "$root/cgi-bin/searchdata";		# directory to store data
$recurse = "true";								# index all subdirectories

# set your password to something else
$password = "mypassword";

# directories to index
# if you want all files on your site use recursive and put "/"
# otherwize you can manually put in your directories here like ("/dir1","/dir2") etc.
@searchdirs = (
"/"
);

# directories not to index
# this is only necessary when:
# A) it's set to recurse directories
# and B) it's is a subdirectory of a directory in @searchdirs that you don't want
@excludedirs = (
"/cgi-bin",
"/myprivatestuff"
);

# by default looks for html,htm,txt,shtml,phtml files
# to change this go to the line with "#### extensions to search" and add more

&ReadParse;

print "Content-type: text/html\n\n";

#-------------------------------------------
# decide what to do

if ($in{'command'} eq "") {
	&displayLogin;
}
elsif ($in{'command'} eq "adminpage") {
	&displayAdmin;
}
elsif ($in{'command'} eq "index") {
	&displayResults;
}

#-------------------------------------------
# the password enter page
sub checkPassword {
	if ($in{'password'} ne $password) {
		print "Access Denied";
		exit(0);
	}
} # end sub checkPassword

#-------------------------------------------
# the password enter page
sub displayLogin {
	print <<"EOF";

<html><title>Search Admin</title>
<form action="search-index.pl" method="post">
<input type="hidden" name="command" value="adminpage">
Enter the password:
<br><input type="password" name="password" size=20>
<br><input type="submit" value="Enter">
</form>
</html>
	
EOF
} # end sub displayLogin

#-------------------------------------------
# the admin page
sub displayAdmin {
	&checkPassword;
	print <<"EOF";
	
<html><title>Search Admin</title>
<form action="search-index.pl" method="post">
<input type="hidden" name="command" value="index">
<input type="hidden" name="password" value="$in{'password'}">

Only thing you can is:
<p><input type="submit" value="Index The Site"> (may take a while)
	
<p>I plan to make online administration of the search settings from here.
</form>
</html>
	
EOF
}

#-------------------------------------------
# index the files and show the results
sub displayResults {
	&checkPassword;
	print "<html><title>Search Index Results</title>";

FIXLOOP: foreach $dir (@searchdirs) {
	my($newdir,$part,@parts);
	@parts = split(/\//,$dir);
	foreach $part (@parts) {
		$part =~ s/ +//g;
		$newdir .= "/$part" if ($part ne "");
	}
	foreach $exclude (@excludedirs) {
		if ($newdir =~ /$exclude/) {
			push(@excludeddirs,$newdir);
			next FIXLOOP;
		}
	}
	push(@searchdirsf,$newdir) if (-d "$root$newdir");
}
if ($recurse eq "true") {
foreach $dir (@searchdirsf) {
	if (-d "$root$dir") {
		opendir(DIR,"$root$dir");
		SWHILE: while ($subdir = readdir DIR) {
			$realdir = "$root$dir/$subdir";
			next unless (-d $realdir);
			next if ($realdir =~ /\./);
			foreach $exclude (@excludedirs) {
				if ($realdir =~ /$exclude/) {
					push(@excludeddirs,$realdir);
					next SWHILE;
				}
			}
			push(@searchdirsf,"$dir/$subdir");
		}
		closedir(DIR);
	}
}
}
foreach $dir (@searchdirsf) {
	opendir(DIR,"$root$dir");
	while ($file = readdir DIR) {
		if ($file =~ /(\.html|\.htm|\.phtml|\.shtml|\.txt)$/) {  #### extensions to search
			push(@searchfiles,"$dir/$file");
		}
	}
	closedir(DIR);
}

for ($i=0;$i<@searchfiles;$i++) {
	$file = $searchfiles[$i];
	open(FILE,"$root$file");
	$contents = join('',<FILE>);
	close(FILE);

	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$adate,$mdate,$ctime,$blksize,$blocks)
	= stat "$root/$file";
	$sizes{$file} = $size;
	$modified{$file} = $mdate;
	$contents =~ s/\n//g;
	if ($contents =~ /(?i)<title>(.*?)<\/title>?/) {
		$titles{$file} = $1;
		$titles{$file} =~ s/,//g;
	}
	else {
		$titles{$file} = "Untitled";
	}
	$contents =~ tr/A-Z/a-z/;
	$contents =~ s/<pre>(.*?)<\/pre>//g;
	$contents =~ s/<[^>]+>/ /g;
	$contents =~ s/ - / /g;
	$contents =~ s/'//g;
	$contents =~ s/[\n\t\`\~\!\@\#\$\%\^\&\*\(\)\_\+\-\=\{\}\|\[\]\\\:\"\;\<\>\?\,\.\/0-9]/ /g;
	@tempwords = split(/ +/,$contents);
	foreach $word (@tempwords) {
		@letters = split(//,$word);
		next if (@letters<=2);
		next if ($words{$word} =~ /$i /);
		next if ($word eq "");
		next if ($word !~ /^[0-9a-z][0-9a-z]*$/);
		$words{$word} .= "$i ";
	}
}

mkdir("$datadir",0777) unless (-d $datadir);

print "<p>Files indexed:";
print "<p><table border=1 cellspacing=0 cellpadding=1>";
print "<tr><td align=\"center\"><b>#</b></td><td><b>Filename</b></td><td align=\"center\"><b>Size</b></td></tr>";
$totalsize = 0;
open(FILE,">$datadir/files");
for ($i=0;$i<@searchfiles;$i++) {
	my($file) = $searchfiles[$i];
	print FILE "$i,$file,$sizes{$file},$modified{$file},$titles{$file}\n";
	print "<tr><td align=\"right\">$i</td><td>$file</td><td align=\"right\">$sizes{$file}</td><tr>";
	$totalsize += $sizes{$file};
}
close(FILE);
print "</table>";

open(FILE,">$datadir/words");
foreach $key (keys(%words)) {
	print FILE "$key = $words{$key}\n";
}
close(FILE);

$totalsize = &round($totalsize/1000,2);
print "<p>Total size of files: $totalsize KB<p>";

if (-e "$datadir/files") {
	my($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$adate,$mdate,$ctime,$blksize,$blocks)
	= stat "$datadir/files";
	$fileindexsize = &round($size/1000,2);
	print "File index: $datadir/files - $fileindexsize KB<br>";
}
else {
	print "ERROR: unable to write $datadir/files (file index)<br>";
}
if (-e "$datadir/words") {
	my($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$adate,$mdate,$ctime,$blksize,$blocks)
	= stat "$datadir/words";
	$wordindexsize = &round($size/1000,2);
	print "Word index: $datadir/words - $wordindexsize KB";
}
else {
	print "ERROR: unable to write $datadir/words (word index)";
}

my($sizeperc) = int(100*($fileindexsize+$wordindexsize)/$totalsize);
print "<p>Size of index by percent: $sizeperc%";

print "<p>You may now <a href=\"search.pl\">Search Your Site</a>";

} # end sub displayResults

#-------------------------------------------
# some helper routines

# get the input
sub ReadParse {
local (*in) = @_ if @_;
local ($i, $loc, $key, $val);
if ($ENV{'REQUEST_METHOD'} eq "GET") {
	$in = $ENV{'QUERY_STRING'};
} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
}
@in = split(/&/,$in);
foreach $i (0 .. $#in) {
	$in[$i] =~ s/\+/ /g;
	($key, $val) = split(/=/,$in[$i],2);
	$key =~ s/%(..)/pack("c",hex($1))/ge;
	$val =~ s/%(..)/pack("c",hex($1))/ge;
	$in{$key} .= "\0" if (defined($in{$key}));
	$in{$key} .= $val;
}
return 1;
} # end sub ReadParse

# round $num to $dec decimal places
sub round {
	my($num,$dec) = @_;
	my($exp) = 10**$dec;
	return(int($num*$exp+$exp/20)/$exp);
} # end sub dec
